//----------------------------------------------------|
//                                 MACD+OSMA v1.1.mq4 |
//                                                    |   
//----------------------------------------------------|

#property  indicator_separate_window
#property  indicator_buffers 6

#property  indicator_color1  RoyalBlue
#property  indicator_color2  RoyalBlue
#property  indicator_color3  Gold
#property  indicator_color4  Violet
#property  indicator_color5  Violet
#property  indicator_color6  Gray
//----------------------------------------------------+
extern int FastEMA=5;
extern int SlowEMA=35;
extern int SignalSMA=10;
extern int SigMA_Mode=1;
extern int MACDShift = 0;
extern int OsMAShift = 0;
extern bool HistogramLine = True;
//----------------------------------------------------+
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];
double     ind_buffer5[];
double     zeroline[];      
//----------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,1);   
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);   
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);    
   SetIndexShift(0,MACDShift);
   SetIndexShift(1,MACDShift);   
   SetIndexShift(2,MACDShift);
   SetIndexShift(3,OsMAShift);
   SetIndexShift(4,OsMAShift);
   SetIndexShift(5,OsMAShift);   
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexDrawBegin(2,SignalSMA);
   SetIndexDrawBegin(3,SignalSMA);
   SetIndexDrawBegin(4,SignalSMA);
   SetIndexDrawBegin(5,SignalSMA);   
   IndicatorBuffers(6);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   if(!SetIndexBuffer(0,ind_buffer1) && 
      !SetIndexBuffer(3,ind_buffer3) &&
      !SetIndexBuffer(5,zeroline) && 
      !SetIndexBuffer(4,ind_buffer4) &&
      !SetIndexBuffer(2,ind_buffer2) &&     
      !SetIndexBuffer(1,ind_buffer5))
      Print("cannot set indicator buffers!");
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")" );
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);    
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,SigMA_Mode,i);
   for(i=0; i<limit; i++)
     {
      ind_buffer3[i]=ind_buffer1[i]-ind_buffer2[i];
      zeroline[i]= 0;
     }
   for(i=0; i<limit; i++)
      if(HistogramLine == true) 
        {
         ind_buffer4[i]=ind_buffer1[i]-ind_buffer2[i];
         ind_buffer5[i]=ind_buffer1[i];
        }
   return(0);
  }